﻿Public Class Form1
    Private oRand As Random
    Dim ticks As Integer = 0

    Dim MA(19) As Integer

    Dim dt As Single = 1 / 20
    Dim P(,) As Single = {{1, 0}, {0, 1}} '2x2 This is the covarience matrix
    Dim angle As Single
    Dim q_bias As Single
    Dim rate As Single
    Dim R_angle As Single = 0.002
    Dim Q_angle As Single = 0.001 'This is the process covarience matrix. It's how much we trust the accelerometer
    Dim Q_gyro As Single = 0.3

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        oRand = New Random(DateTime.Now.Millisecond)

        For i = 0 To 19
            MA(i) = 0
        Next
    End Sub

    Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
        If btnStartStop.Text = "Start" Then
            btnStartStop.Text = "Stop"
            Timer1.Start()
        Else
            btnStartStop.Text = "Start"
            Timer1.Stop()
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ticks += 1
        If ticks = 5 Then ticks = 0

        Dim inval As Integer = sliderInput.Value
        Dim noiselevel As Integer = sliderNoiseLevel.Value
        Dim additionalbias As Integer = sliderBias.Value
        Dim scalefactor As Single = (sliderScale.Value / 100) + 1 'This should be between 1 and 2
        Dim iRand As Integer = oRand.Next(0, noiselevel)
        Dim NVal As Integer = CInt((inval * scalefactor) + additionalbias + iRand - (noiselevel / 2))

        If NVal < 0 Then NVal = 0
        If NVal > 1000 Then NVal = 1000
        sliderNoisyInput.Value = NVal




        'This is an average of the last 20 points.
        Dim total As Integer = NVal
        For i = 0 To 18
            MA(i) = MA(i + 1)
            total += MA(i)
        Next
        MA(19) = NVal
        Dim AverageOutput As Single = total / 20

        If AverageOutput < 0 Then AverageOutput = 0
        If AverageOutput > 1000 Then AverageOutput = 1000
        sliderAvgOutput.Value = CInt(AverageOutput)

        Dim AverageDiff As Integer = CInt(Math.Abs(AverageOutput - inval) * 10)
        If AverageDiff > 1000 Then AverageDiff = 1000
        sliderAvgDiff.Value = AverageDiff




        'The Kalman Filter code comes from:
        'http://www.rotomotion.com/downloads/tilt.c

        'This is the Kalman Filter
        State_Update(NVal)
        'If ticks = 1 Then Kalman_Update(inval) 'This updates the filter every 5 cycles
        Kalman_Update(inval) 'This updates the filter every cycle
        Dim KalmanOutput As Single = angle

        If KalmanOutput < 0 Then KalmanOutput = 0
        If KalmanOutput > 1000 Then KalmanOutput = 1000
        sliderKalmanOutput.Value = CInt(KalmanOutput)

        Dim KalmanDiff As Integer = CInt(Math.Abs(KalmanOutput - inval) * 10)
        If KalmanDiff > 1000 Then KalmanDiff = 1000
        sliderKalmanDiff.Value = KalmanDiff
    End Sub

    Private Sub State_Update(ByVal q_m As Single)
        Dim q As Single = q_m - q_bias 'Unbias our gyro
        Dim Pdot() As Single = {Q_angle - P(0, 1) - P(1, 0), -P(1, 1), -P(1, 1), Q_gyro}
        rate = q 'Store our unbias gyro estimate
        angle += q * dt

        'Update the covariance matrix
        P(0, 0) += Pdot(0) * dt
        P(0, 1) += Pdot(1) * dt
        P(1, 0) += Pdot(2) * dt
        P(1, 1) += Pdot(3) * dt
    End Sub

    Private Sub Kalman_Update(ByVal actualinput As Single)
        Dim angle_m As Single = actualinput
        Dim angle_err As Single = angle_m - angle
        Dim C_0 As Single = 1
        Dim PCt_0 = C_0 * P(0, 0) '+ C_1 * P(0, 1) 'This second part is always 0, so we don't bother
        Dim PCt_1 = C_0 * P(1, 0) '+ C_1 * P(1, 1)
        Dim E As Single = R_angle + C_0 * PCt_0 'Compute the error estimate.
        Dim K_0 As Single = PCt_0 / E 'Compute the Kalman filter gains
        Dim K_1 As Single = PCt_1 / E
        Dim t_0 As Single = PCt_0
        Dim t_1 As Single = C_0 * P(0, 1)

        P(0, 0) -= K_0 * t_0 'Update covariance matrix
        P(0, 1) -= K_0 * t_1
        P(1, 0) -= K_1 * t_0
        P(1, 1) -= K_1 * t_1

        angle += K_0 * angle_err 'Update our state estimate
        q_bias += K_1 * angle_err

    End Sub

End Class
